diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/build-support/macros-and-definitions.cmake ns-3.41/build-support/macros-and-definitions.cmake
--- ns-3.40/build-support/macros-and-definitions.cmake	2023-09-27 13:30:37.530838700 -0700
+++ ns-3.41/build-support/macros-and-definitions.cmake	2024-02-09 14:44:07.725788800 -0800
@@ -1875,670 +1369,41 @@
 
   if((NOT missing_dependencies) AND ${filtered_in})
     # Convert boolean into text to forward argument
+    set(IGNORE_PCH)
     if(${EXAMPLE_IGNORE_PCH})
-      set(IGNORE_PCH IGNORE_PCH)
-    endif()
-    # Create example library with sources and headers
-    # cmake-format: off
-    build_exec(
-      EXECNAME ${EXAMPLE_NAME}
-      SOURCE_FILES ${EXAMPLE_SOURCE_FILES}
-      HEADER_FILES ${EXAMPLE_HEADER_FILES}
-      LIBRARIES_TO_LINK ${EXAMPLE_LIBRARIES_TO_LINK} ${optional_visualizer_lib}
-      EXECUTABLE_DIRECTORY_PATH
-        ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/examples/${examplefolder}/
-      ${IGNORE_PCH}
-    )
-    # cmake-format: on
-  endif()
-endmacro()
-
-function(filter_modules modules_to_filter all_modules_list filter_in)
-  set(new_modules_to_build)
-  # We are receiving variable names as arguments, so we have to "dereference"
-  # them first That is why we have the duplicated ${${}}
-  foreach(module ${${all_modules_list}})
-    if(${filter_in} (${module} IN_LIST ${modules_to_filter}))
-      list(APPEND new_modules_to_build ${module})
-    endif()
-  endforeach()
-  set(${all_modules_list} ${new_modules_to_build} PARENT_SCOPE)
-endfunction()
-
-function(resolve_dependencies module_name dependencies contrib_dependencies)
-  # Create cache variables to hold dependencies list and visited
-  set(dependency_visited "" CACHE INTERNAL "")
-  set(contrib_dependency_visited "" CACHE INTERNAL "")
-  recursive_dependency(${module_name})
-  if(${module_name} IN_LIST dependency_visited)
-    set(temp ${dependency_visited})
-    list(REMOVE_AT temp 0)
-    set(${dependencies} ${temp} PARENT_SCOPE)
-    set(${contrib_dependencies} ${contrib_dependency_visited} PARENT_SCOPE)
-  else()
-    set(temp ${contrib_dependency_visited})
-    list(REMOVE_AT temp 0)
-    set(${dependencies} ${dependency_visited} PARENT_SCOPE)
-    set(${contrib_dependencies} ${temp} PARENT_SCOPE)
-  endif()
-  unset(dependency_visited CACHE)
-  unset(contrib_dependency_visited CACHE)
-endfunction()
-
-function(filter_libraries cmakelists_contents libraries)
-  string(REGEX MATCHALL "{lib[^}]*[^obj]}" matches "${cmakelists_content}")
-  list(REMOVE_ITEM matches "{libraries_to_link}")
-  string(REPLACE "{lib\${name" "" matches "${matches}") # special case for
-                                                        # src/test
-  string(REPLACE "{lib" "" matches "${matches}")
-  string(REPLACE "}" "" matches "${matches}")
-  set(${libraries} ${matches} PARENT_SCOPE)
-endfunction()
-
-function(recursive_dependency module_name)
-  # Read module CMakeLists.txt and search for ns-3 modules
-  set(src_cmakelist ${PROJECT_SOURCE_DIR}/src/${module_name}/CMakeLists.txt)
-  set(contrib_cmakelist
-      ${PROJECT_SOURCE_DIR}/contrib/${module_name}/CMakeLists.txt
-  )
-  set(contrib FALSE)
-  if(EXISTS ${src_cmakelist})
-    file(READ ${src_cmakelist} cmakelists_content)
-  elseif(EXISTS ${contrib_cmakelist})
-    file(READ ${contrib_cmakelist} cmakelists_content)
-    set(contrib TRUE)
-  else()
-    set(cmakelists_content "")
-    message(${HIGHLIGHTED_STATUS}
-            "The CMakeLists.txt file for module ${module_name} was not found."
-    )
-  endif()
-
-  filter_libraries("${cmakelists_content}" matches)
-
-  # Add this visited module dependencies to the dependencies list
-  if(contrib)
-    set(contrib_dependency_visited
-        "${contrib_dependency_visited};${module_name}" CACHE INTERNAL ""
-    )
-    set(examples_cmakelists ${contrib_cmakelist})
-  else()
-    set(dependency_visited "${dependency_visited};${module_name}" CACHE INTERNAL
-                                                                        ""
-    )
-    set(examples_cmakelists ${src_cmakelist})
-  endif()
-
-  # cmake-format: off
-  # Scan dependencies required by this module examples
-  #if(${ENABLE_EXAMPLES})
-  #  string(REPLACE "${module_name}" "${module_name}/examples" examples_cmakelists ${examples_cmakelists})
-  #  if(EXISTS ${examples_cmakelists})
-  #    file(READ ${examples_cmakelists} cmakelists_content)
-  #    filter_libraries(${cmakelists_content} example_matches)
-  #  endif()
-  #endif()
-  # cmake-format: on
-
-  # For each dependency, call this same function
-  set(matches "${matches};${example_matches}")
-  foreach(match ${matches})
-    if(NOT ((${match} IN_LIST dependency_visited)
-            OR (${match} IN_LIST contrib_dependency_visited))
-    )
-      recursive_dependency(${match})
+      set(IGNORE_PCH "IGNORE_PCH")
     endif()
-  endforeach()
-endfunction()
-
-macro(
-  filter_enabled_and_disabled_modules
-  libs_to_build
-  contrib_libs_to_build
-  NS3_ENABLED_MODULES
-  NS3_DISABLED_MODULES
-  ns3rc_enabled_modules
-  ns3rc_disabled_modules
-)
-  mark_as_advanced(ns3-all-enabled-modules)
 
-  # Before filtering, we set a variable with all scanned modules in the src
-  # directory
-  set(scanned_modules ${${libs_to_build}})
-
-  # Ensure enabled and disable modules lists are using semicolons
-  string(REPLACE "," ";" ${NS3_ENABLED_MODULES} "${${NS3_ENABLED_MODULES}}")
-  string(REPLACE "," ";" ${NS3_DISABLED_MODULES} "${${NS3_DISABLED_MODULES}}")
-
-  # Now that scanning modules finished, we can remove the disabled modules or
-  # replace the modules list with the ones in the enabled list
-  if(${NS3_ENABLED_MODULES} OR ${ns3rc_enabled_modules})
-    # List of enabled modules passed by the command line overwrites list read
-    # from ns3rc
-    if(${NS3_ENABLED_MODULES})
-      set(ns3rc_enabled_modules ${${NS3_ENABLED_MODULES}})
-    endif()
-
-    # Filter enabled modules
-    filter_modules(ns3rc_enabled_modules libs_to_build "")
-    filter_modules(ns3rc_enabled_modules contrib_libs_to_build "")
-
-    # Use recursion to automatically determine dependencies required by the
-    # manually enabled modules
-    foreach(lib ${${contrib_libs_to_build}})
-      resolve_dependencies(${lib} dependencies contrib_dependencies)
-      list(APPEND ${contrib_libs_to_build} "${contrib_dependencies}")
-      list(APPEND ${libs_to_build} "${dependencies}")
-      unset(dependencies)
-      unset(contrib_dependencies)
-    endforeach()
-
-    foreach(lib ${${libs_to_build}})
-      resolve_dependencies(${lib} dependencies contrib_dependencies)
-      list(APPEND ${libs_to_build} "${dependencies}")
-      unset(dependencies)
-      unset(contrib_dependencies)
-    endforeach()
-  endif()
-
-  if(${NS3_DISABLED_MODULES} OR ${ns3rc_disabled_modules})
-    # List of disabled modules passed by the command line overwrites list read
-    # from ns3rc
-
-    if(${NS3_DISABLED_MODULES})
-      set(ns3rc_disabled_modules ${${NS3_DISABLED_MODULES}})
-    endif()
-
-    set(all_libs ${${libs_to_build}};${${contrib_libs_to_build}})
-
-    # We then use the recursive dependency finding to get all dependencies of
-    # all modules
-    foreach(lib ${all_libs})
-      resolve_dependencies(${lib} dependencies contrib_dependencies)
-      set(${lib}_dependencies "${dependencies};${contrib_dependencies}")
-      unset(dependencies)
-      unset(contrib_dependencies)
-    endforeach()
-
-    # Now we can begin removing libraries that require disabled dependencies
-    set(disabled_libs "${${ns3rc_disabled_modules}}")
-    foreach(libo ${all_libs})
-      foreach(lib ${all_libs})
-        foreach(disabled_lib ${disabled_libs})
-          if(${lib} STREQUAL ${disabled_lib})
-            continue()
-          endif()
-          if(${disabled_lib} IN_LIST ${lib}_dependencies)
-            list(APPEND disabled_libs ${lib})
-            break() # proceed to the next lib in all_libs
-          endif()
-        endforeach()
-      endforeach()
-    endforeach()
-
-    # Clean dependencies lists
-    foreach(lib ${all_libs})
-      unset(${lib}_dependencies)
-    endforeach()
-
-    # We can filter out disabled modules
-    filter_modules(disabled_libs libs_to_build "NOT")
-    filter_modules(disabled_libs contrib_libs_to_build "NOT")
-
-    if(core IN_LIST ${libs_to_build})
-      list(APPEND ${libs_to_build} test) # include test module
-    endif()
-  endif()
-
-  # Older CMake versions require this workaround for empty lists
-  if(NOT ${contrib_libs_to_build})
-    set(${contrib_libs_to_build} "")
-  endif()
-
-  # Filter out any eventual duplicates
-  list(REMOVE_DUPLICATES ${libs_to_build})
-  list(REMOVE_DUPLICATES ${contrib_libs_to_build})
-
-  # Export list with all enabled modules (used to separate ns libraries from
-  # non-ns libraries in ns3_module_macros)
-  set(ns3-all-enabled-modules "${${libs_to_build}};${${contrib_libs_to_build}}"
-      CACHE INTERNAL "list with all enabled modules"
-  )
-endmacro()
-
-# Parse .ns3rc
-macro(parse_ns3rc enabled_modules disabled_modules examples_enabled
-      tests_enabled
-)
-  # Try to find .ns3rc
-  find_file(NS3RC .ns3rc PATHS /etc $ENV{HOME} $ENV{USERPROFILE}
-                               ${PROJECT_SOURCE_DIR} NO_CACHE
-  )
-
-  # Set variables with default values (all modules, no examples nor tests)
-  set(${enabled_modules} "")
-  set(${disabled_modules} "")
-  set(${examples_enabled} "FALSE")
-  set(${tests_enabled} "FALSE")
-
-  if(NOT (${NS3RC} STREQUAL "NS3RC-NOTFOUND"))
-    message(${HIGHLIGHTED_STATUS}
-            "Configuration file .ns3rc being used : ${NS3RC}"
+    set(current_directory ${CMAKE_CURRENT_SOURCE_DIR})
+    string(REPLACE "${PROJECT_SOURCE_DIR}" "" current_directory
+                   "${current_directory}"
     )
-    file(READ ${NS3RC} ns3rc_contents)
-    # Check if ns3rc file is CMake or Python based and act accordingly
-    if(ns3rc_contents MATCHES "ns3rc_*")
-      include(${NS3RC})
-    else()
-      parse_python_ns3rc(
-        "${ns3rc_contents}" ${enabled_modules} ${examples_enabled}
-        ${tests_enabled} ${NS3RC}
+    if("${current_directory}" MATCHES ".*/(src|contrib)/.*")
+      message(
+        FATAL_ERROR
+          "build_example() macro is meant for ns-3-dev/examples, and not for modules. Use build_lib_example() instead."
       )
     endif()
-  endif()
-endmacro(parse_ns3rc)
-
-function(parse_python_ns3rc ns3rc_contents enabled_modules examples_enabled
-         tests_enabled ns3rc_location
-)
-  # Save .ns3rc backup
-  file(WRITE ${ns3rc_location}.backup ${ns3rc_contents})
-
-  # Match modules_enabled list
-  if(ns3rc_contents MATCHES "modules_enabled.*\\[(.*).*\\]")
-    set(${enabled_modules} ${CMAKE_MATCH_1})
-    if(${enabled_modules} MATCHES "all_modules")
-      # If all modules, just clean the filter and all modules will get built by
-      # default
-      set(${enabled_modules})
-    else()
-      # If modules are listed, remove quotes and replace commas with semicolons
-      # transforming a string into a cmake list
-      string(REPLACE "," ";" ${enabled_modules} "${${enabled_modules}}")
-      string(REPLACE "'" "" ${enabled_modules} "${${enabled_modules}}")
-      string(REPLACE "\"" "" ${enabled_modules} "${${enabled_modules}}")
-      string(REPLACE " " "" ${enabled_modules} "${${enabled_modules}}")
-      string(REPLACE "\n" ";" ${enabled_modules} "${${enabled_modules}}")
-      list(SORT ${enabled_modules})
-
-      # Remove possibly empty entry
-      list(REMOVE_ITEM ${enabled_modules} "")
-      foreach(element ${${enabled_modules}})
-        # Inspect each element for comments
-        if(${element} MATCHES "#.*")
-          list(REMOVE_ITEM ${enabled_modules} ${element})
-        endif()
-      endforeach()
-    endif()
-  endif()
-
-  string(REPLACE "True" "ON" ns3rc_contents ${ns3rc_contents})
-  string(REPLACE "False" "OFF" ns3rc_contents ${ns3rc_contents})
-
-  # Match examples_enabled flag
-  if(ns3rc_contents MATCHES "examples_enabled = (ON|OFF)")
-    set(${examples_enabled} ${CMAKE_MATCH_1})
-  endif()
-
-  # Match tests_enabled flag
-  if(ns3rc_contents MATCHES "tests_enabled = (ON|OFF)")
-    set(${tests_enabled} ${CMAKE_MATCH_1})
-  endif()
-
-  # Save variables to parent scope
-  set(${enabled_modules} "${${enabled_modules}}" PARENT_SCOPE)
-  set(${examples_enabled} "${${examples_enabled}}" PARENT_SCOPE)
-  set(${tests_enabled} "${${tests_enabled}}" PARENT_SCOPE)
-
-  # Save updated .ns3rc file
-  message(
-    ${HIGHLIGHTED_STATUS}
-    "The python-based .ns3rc file format is deprecated and was updated to the CMake format"
-  )
-  configure_file(
-    ${PROJECT_SOURCE_DIR}/build-support/.ns3rc-template ${ns3rc_location} @ONLY
-  )
-endfunction(parse_python_ns3rc)
 
-function(log_find_searched_paths)
-  # Parse arguments
-  set(options)
-  set(oneValueArgs TARGET_TYPE TARGET_NAME SEARCH_RESULT SEARCH_SYSTEM_PREFIX)
-  set(multiValueArgs SEARCH_PATHS SEARCH_SUFFIXES)
-  cmake_parse_arguments(
-    "LOGFIND" "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN}
-  )
-
-  # Get searched paths and add cmake_system_prefix_path if not explicitly marked
-  # not to include it
-  set(tsearch_paths ${LOGFIND_SEARCH_PATHS})
-  if("${LOGFIND_SEARCH_SYSTEM_PREFIX}" STREQUAL "")
-    list(APPEND tsearch_paths "${CMAKE_SYSTEM_PREFIX_PATH}")
-  endif()
-
-  set(log_find
-      "Looking for ${LOGFIND_TARGET_TYPE} ${LOGFIND_TARGET_NAME} in:\n"
-  )
-  # For each search path and suffix combination, print a line
-  foreach(tsearch_path ${tsearch_paths})
-    foreach(suffix ${LOGFIND_SEARCH_SUFFIXES})
-      string(APPEND log_find
-             "\t${tsearch_path}${suffix}/${LOGFIND_TARGET_NAME}\n"
-      )
-    endforeach()
-  endforeach()
+    get_filename_component(examplefolder ${CMAKE_CURRENT_SOURCE_DIR} NAME)
 
-  # Add a final line saying if the file was found and where, or if it was not
-  # found
-  if("${${LOGFIND_SEARCH_RESULT}}" STREQUAL "${LOGFIND_SEARCH_RESULT}-NOTFOUND")
-    string(APPEND log_find
-           "\n\t${LOGFIND_TARGET_TYPE} ${LOGFIND_TARGET_NAME} was not found\n"
-    )
-  else()
-    string(
-      APPEND
-      log_find
-      "\n\t${LOGFIND_TARGET_TYPE} ${LOGFIND_TARGET_NAME} was found in ${${LOGFIND_SEARCH_RESULT}}\n"
-    )
-  endif()
-
-  # Replace duplicate path separators
-  string(REPLACE "//" "/" log_find "${log_find}")
-
-  # Print find debug message similar to the one produced by
-  # CMAKE_FIND_DEBUG_MODE=true in CMake >= 3.17
-  message(STATUS ${log_find})
-endfunction()
-
-function(find_external_library)
-  # Parse arguments
-  set(options QUIET)
-  set(oneValueArgs DEPENDENCY_NAME HEADER_NAME LIBRARY_NAME)
-  set(multiValueArgs HEADER_NAMES LIBRARY_NAMES PATH_SUFFIXES SEARCH_PATHS)
-  cmake_parse_arguments(
-    "FIND_LIB" "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN}
-  )
-
-  # Set the external package/dependency name
-  set(name ${FIND_LIB_DEPENDENCY_NAME})
-
-  # We process individual and list of headers and libraries by transforming them
-  # into lists
-  set(library_names "${FIND_LIB_LIBRARY_NAME};${FIND_LIB_LIBRARY_NAMES}")
-  set(header_names "${FIND_LIB_HEADER_NAME};${FIND_LIB_HEADER_NAMES}")
-
-  # Just changing the parsed argument name back to something shorter
-  set(search_paths ${FIND_LIB_SEARCH_PATHS})
-  set(path_suffixes "${FIND_LIB_PATH_SUFFIXES}")
-
-  set(not_found_libraries)
-  set(library_dirs)
-  set(libraries)
-
-  # Include parent directories in the search paths to handle Bake cases
-  get_filename_component(parent_project_dir ${PROJECT_SOURCE_DIR} DIRECTORY)
-  get_filename_component(
-    grandparent_project_dir ${parent_project_dir} DIRECTORY
-  )
-  set(project_parent_dirs ${parent_project_dir} ${grandparent_project_dir})
-
-  # Paths and suffixes where libraries will be searched on
-  set(library_search_paths
-      ${search_paths}
-      ${project_parent_dirs}
-      ${CMAKE_OUTPUT_DIRECTORY} # Search for libraries in ns-3-dev/build
-      ${CMAKE_INSTALL_PREFIX} # Search for libraries in the install directory
-                              # (e.g. /usr/)
-      $ENV{LD_LIBRARY_PATH} # Search for libraries in LD_LIBRARY_PATH
-                            # directories
-      $ENV{PATH} # Search for libraries in PATH directories
-  )
-  # cmake-format: off
-  #
-  # Split : separated entries from environment variables
-  # by replacing separators with ;
-  #
-  # cmake-format: on
-  string(REPLACE ":" ";" library_search_paths "${library_search_paths}")
-
-  set(suffixes /build /lib /build/lib / /bin ${path_suffixes})
-
-  # For each of the library names in LIBRARY_NAMES or LIBRARY_NAME
-  foreach(library ${library_names})
-    # We mark this value is advanced not to pollute the configuration with
-    # ccmake with the cache variables used internally
-    mark_as_advanced(${name}_library_internal_${library})
-
-    # We search for the library named ${library} and store the results in
-    # ${name}_library_internal_${library}
-    find_library(
-      ${name}_library_internal_${library} ${library}
-      HINTS ${library_search_paths} PATH_SUFFIXES ${suffixes}
-    )
+    # Create example library with sources and headers
     # cmake-format: off
-    # Note: the PATH_SUFFIXES above apply to *ALL* PATHS and HINTS Which
-    # translates to CMake searching on standard library directories
-    # CMAKE_SYSTEM_PREFIX_PATH, user-settable CMAKE_PREFIX_PATH or
-    # CMAKE_LIBRARY_PATH and the directories listed above
-    #
-    # e.g.  from Ubuntu 22.04 CMAKE_SYSTEM_PREFIX_PATH =
-    # /usr/local;/usr;/;/usr/local;/usr/X11R6;/usr/pkg;/opt
-    #
-    # Searched directories without suffixes
-    #
-    # ${CMAKE_SYSTEM_PREFIX_PATH}[0] = /usr/local/
-    # ${CMAKE_SYSTEM_PREFIX_PATH}[1] = /usr
-    # ${CMAKE_SYSTEM_PREFIX_PATH}[2] = /
-    # ...
-    # ${CMAKE_SYSTEM_PREFIX_PATH}[6] = /opt
-    # ${LD_LIBRARY_PATH}[0]
-    # ...
-    # ${LD_LIBRARY_PATH}[m]
-    # ${PATH}[0]
-    # ...
-    # ${PATH}[m]
-    #
-    # Searched directories with suffixes include all of the directories above
-    # plus all suffixes
-    # PATH_SUFFIXES /build /lib /build/lib / /bin # ${path_suffixes}
-    #
-    # /usr/local/build
-    # /usr/local/lib
-    # /usr/local/build/lib
-    # /usr/local/bin
-    # ...
-    #
-    # cmake-format: on
-    # Or enable NS3_VERBOSE to print the searched paths
-
-    # Print tested paths to the searched library and if it was found
-    if(${NS3_VERBOSE} AND (${CMAKE_VERSION} VERSION_LESS "3.17.0"))
-      log_find_searched_paths(
-        TARGET_TYPE
-        Library
-        TARGET_NAME
-        ${library}
-        SEARCH_RESULT
-        ${name}_library_internal_${library}
-        SEARCH_PATHS
-        ${library_search_paths}
-        SEARCH_SUFFIXES
-        ${suffixes}
-      )
-    endif()
-
-    # After searching the library, the internal variable should have either the
-    # absolute path to the library or the name of the variable appended with
-    # -NOTFOUND
-    if("${${name}_library_internal_${library}}" STREQUAL
-       "${name}_library_internal_${library}-NOTFOUND"
-    )
-      # We keep track of libraries that were not found
-      list(APPEND not_found_libraries ${library})
-    else()
-      # We get the name of the parent directory of the library and append the
-      # library to a list of found libraries
-      get_filename_component(
-        ${name}_library_dir_internal ${${name}_library_internal_${library}}
-        DIRECTORY
-      ) # e.g. lib/openflow.(so|dll|dylib|a) -> lib
-      list(APPEND library_dirs ${${name}_library_dir_internal})
-      list(APPEND libraries ${${name}_library_internal_${library}})
-    endif()
-  endforeach()
-
-  # For each library that was found (e.g. /usr/lib/pthread.so), get their parent
-  # directory (/usr/lib) and its parent (/usr)
-  set(parent_dirs)
-  foreach(libdir ${library_dirs})
-    get_filename_component(parent_libdir ${libdir} DIRECTORY)
-    get_filename_component(parent_parent_libdir ${parent_libdir} DIRECTORY)
-    list(APPEND parent_dirs ${libdir} ${parent_libdir} ${parent_parent_libdir})
-  endforeach()
-
-  set(header_search_paths
-      ${search_paths}
-      ${parent_dirs}
-      ${project_parent_dirs}
-      ${CMAKE_OUTPUT_DIRECTORY} # Search for headers in
-      # ns-3-dev/build
-      ${CMAKE_INSTALL_PREFIX} # Search for headers in the install
-  )
-
-  set(not_found_headers)
-  set(include_dirs)
-  foreach(header ${header_names})
-    # The same way with libraries, we mark the internal variable as advanced not
-    # to pollute ccmake configuration with variables used internally
-    mark_as_advanced(${name}_header_internal_${header})
-    set(suffixes
-        /build
-        /include
-        /build/include
-        /build/include/${name}
-        /include/${name}
-        /${name}
-        /
-        ${path_suffixes}
+    build_exec(
+            EXECNAME ${EXAMPLE_NAME}
+            SOURCE_FILES ${EXAMPLE_SOURCE_FILES}
+            HEADER_FILES ${EXAMPLE_HEADER_FILES}
+            LIBRARIES_TO_LINK ${EXAMPLE_LIBRARIES_TO_LINK} ${ns3-optional-visualizer-lib}
+            EXECUTABLE_DIRECTORY_PATH
+            ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/examples/${examplefolder}/
+            ${IGNORE_PCH}
     )
-
-    # cmake-format: off
-    # Here we search for the header file named ${header} and store the result in
-    # ${name}_header_internal_${header}
-    #
-    # The same way we did with libraries, here we search on
-    # CMAKE_SYSTEM_PREFIX_PATH, along with user-settable ${search_paths}, the
-    # parent directories from the libraries, CMAKE_OUTPUT_DIRECTORY and
-    # CMAKE_INSTALL_PREFIX
-    #
-    # And again, for each of them, for every suffix listed /usr/local/build
-    # /usr/local/include
-    # /usr/local/build/include
-    # /usr/local/build/include/${name}
-    # /usr/local/include/${name}
-    # ...
-    #
     # cmake-format: on
-    # Or enable NS3_VERBOSE to get the searched paths printed while configuring
-
-    find_file(${name}_header_internal_${header} ${header}
-              HINTS ${header_search_paths} # directory (e.g. /usr/)
-                    ${header_skip_system_prefix} PATH_SUFFIXES ${suffixes}
-    )
-
-    # Print tested paths to the searched header and if it was found
-    if(${NS3_VERBOSE} AND (${CMAKE_VERSION} VERSION_LESS "3.17.0"))
-      log_find_searched_paths(
-        TARGET_TYPE
-        Header
-        TARGET_NAME
-        ${header}
-        SEARCH_RESULT
-        ${name}_header_internal_${header}
-        SEARCH_PATHS
-        ${header_search_paths}
-        SEARCH_SUFFIXES
-        ${suffixes}
-        SEARCH_SYSTEM_PREFIX
-        ${header_skip_system_prefix}
-      )
-    endif()
-
-    # If the header file was not found, append to the not-found list
-    if("${${name}_header_internal_${header}}" STREQUAL
-       "${name}_header_internal_${header}-NOTFOUND"
-    )
-      list(APPEND not_found_headers ${header})
-    else()
-      # If the header file was found, get their directories and the parent of
-      # their directories to add as include directories
-      get_filename_component(
-        header_include_dir ${${name}_header_internal_${header}} DIRECTORY
-      ) # e.g. include/click/ (simclick.h) -> #include <simclick.h> should work
-      get_filename_component(
-        header_include_dir2 ${header_include_dir} DIRECTORY
-      ) # e.g. include/(click) -> #include <click/simclick.h> should work
-      list(APPEND include_dirs ${header_include_dir} ${header_include_dir2})
-    endif()
-  endforeach()
-
-  # Remove duplicate include directories
-  if(include_dirs)
-    list(REMOVE_DUPLICATES include_dirs)
   endif()
+endmacro()
 
-  # If we find both library and header, we export their values
-  if((NOT not_found_libraries) AND (NOT not_found_headers))
-    set(${name}_INCLUDE_DIRS "${include_dirs}" PARENT_SCOPE)
-    set(${name}_LIBRARIES "${libraries}" PARENT_SCOPE)
-    set(${name}_HEADER ${${name}_header_internal} PARENT_SCOPE)
-    set(${name}_FOUND TRUE PARENT_SCOPE)
-    if(NOT ${FIND_LIB_QUIET})
-      message(STATUS "find_external_library: ${name} was found.")
-    endif()
-  else()
-    set(${name}_INCLUDE_DIRS PARENT_SCOPE)
-    set(${name}_LIBRARIES PARENT_SCOPE)
-    set(${name}_HEADER PARENT_SCOPE)
-    set(${name}_FOUND FALSE PARENT_SCOPE)
-    if(NOT ${FIND_LIB_QUIET})
-      message(
-        ${HIGHLIGHTED_STATUS}
-        "find_external_library: ${name} was not found. Missing headers: \"${not_found_headers}\" and missing libraries: \"${not_found_libraries}\"."
-      )
-    endif()
-  endif()
-endfunction()
-
-function(get_target_includes target output)
-  set(include_directories)
-  get_target_property(include_dirs ${target} INCLUDE_DIRECTORIES)
-  list(REMOVE_DUPLICATES include_dirs)
-  foreach(include_dir ${include_dirs})
-    if(include_dir MATCHES "<")
-      # Skip CMake build and install interface includes
-      continue()
-    else()
-      # Append the include directory to a list
-      set(include_directories ${include_directories} -I${include_dir})
-    endif()
-  endforeach()
-  set(${output} ${include_directories} PARENT_SCOPE)
-endfunction()
-
-function(check_python_packages packages missing_packages)
-  set(missing)
-  foreach(package ${packages})
-    execute_process(
-      COMMAND ${Python3_EXECUTABLE} -c "import ${package}"
-      RESULT_VARIABLE return_code OUTPUT_QUIET ERROR_QUIET
-    )
-    if(NOT (${return_code} EQUAL 0))
-      list(APPEND missing ${package})
-    endif()
-  endforeach()
-  set(${missing_packages} "${missing}" PARENT_SCOPE)
-endfunction()
+# Macros to write the lock file
+include(ns3-lock)
 
-include(build-support/custom-modules/ns3-lock.cmake)
-include(build-support/custom-modules/ns3-configtable.cmake)
+# Macros to build the config table file
+include(ns3-configtable)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/build-support/pip-wheel/auditwheel-exclude-list.py ns-3.41/build-support/pip-wheel/auditwheel-exclude-list.py
--- ns-3.40/build-support/pip-wheel/auditwheel-exclude-list.py	2023-09-27 13:30:37.530838700 -0700
+++ ns-3.41/build-support/pip-wheel/auditwheel-exclude-list.py	2024-02-09 14:44:07.725788800 -0800
@@ -8,4 +8,4 @@
         continue
     for lib in os.listdir(lib_dir):
         if "libns3" in lib:
-            print(f"--exclude {lib}", end=' ')
+            print(f"--exclude {lib}", end=" ")
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/build-support/pip-wheel/ns/__init__.py ns-3.41/build-support/pip-wheel/ns/__init__.py
--- ns-3.40/build-support/pip-wheel/ns/__init__.py	2023-09-27 13:30:37.530838700 -0700
+++ ns-3.41/build-support/pip-wheel/ns/__init__.py	2024-02-09 14:44:07.725788800 -0800
@@ -4,7 +4,8 @@
 
 try:
     import ns3.ns
-    sys.modules['ns'] = ns3.ns
+
+    sys.modules["ns"] = ns3.ns
 except ModuleNotFoundError as e:
     print("Install the ns3 package with pip install ns3.", file=sys.stderr)
     exit(-1)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/build-support/pip-wheel/visualizer/__init__.py ns-3.41/build-support/pip-wheel/visualizer/__init__.py
--- ns-3.40/build-support/pip-wheel/visualizer/__init__.py	2023-09-27 13:30:37.530838700 -0700
+++ ns-3.41/build-support/pip-wheel/visualizer/__init__.py	2024-02-09 14:44:07.725788800 -0800
@@ -8,4 +8,4 @@
     print("Install the ns3 package with pip install ns3.", file=sys.stderr)
     exit(-1)
 
-from ns3.visualizer import start, register_plugin, set_bounds, add_initialization_hook
+from ns3.visualizer import add_initialization_hook, register_plugin, set_bounds, start
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/build-support/test-files/test-src-dependent-on-contrib/CMakeLists.txt ns-3.41/build-support/test-files/test-src-dependent-on-contrib/CMakeLists.txt
--- ns-3.40/build-support/test-files/test-src-dependent-on-contrib/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.41/build-support/test-files/test-src-dependent-on-contrib/CMakeLists.txt	2024-02-09 14:44:07.725788800 -0800
@@ -0,0 +1,8 @@
+build_lib(
+        LIBNAME test-src-dependent-on-contrib
+        SOURCE_FILES src-source.cc
+        HEADER_FILES src-header.h
+        LIBRARIES_TO_LINK ${libcore}
+                          ${libtest-contrib-dependency}
+)
+
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/build-support/test-files/test-src-dependent-on-contrib/examples/CMakeLists.txt ns-3.41/build-support/test-files/test-src-dependent-on-contrib/examples/CMakeLists.txt
--- ns-3.40/build-support/test-files/test-src-dependent-on-contrib/examples/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.41/build-support/test-files/test-src-dependent-on-contrib/examples/CMakeLists.txt	2024-02-09 14:44:07.725788800 -0800
@@ -0,0 +1,6 @@
+build_lib_example(
+        NAME source-example
+        SOURCE_FILES source-example.cc
+        LIBRARIES_TO_LINK
+        ${libtest-src-dependent-on-contrib}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/build-support/test-files/test-src-dependent-on-contrib/examples/source-example.cc ns-3.41/build-support/test-files/test-src-dependent-on-contrib/examples/source-example.cc
--- ns-3.40/build-support/test-files/test-src-dependent-on-contrib/examples/source-example.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.41/build-support/test-files/test-src-dependent-on-contrib/examples/source-example.cc	2024-02-09 14:44:07.725788800 -0800
@@ -0,0 +1,8 @@
+#include <ns3/src-header.h>
+
+int
+main()
+{
+    testPrint2();
+    return 0;
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/build-support/test-files/test-src-dependent-on-contrib/src-header.h ns-3.41/build-support/test-files/test-src-dependent-on-contrib/src-header.h
--- ns-3.40/build-support/test-files/test-src-dependent-on-contrib/src-header.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.41/build-support/test-files/test-src-dependent-on-contrib/src-header.h	2024-02-09 14:44:07.725788800 -0800
@@ -0,0 +1,6 @@
+#ifndef NS3_SRC_SOURCE2_H
+#define NS3_SRC_SOURCE2_H
+
+void testPrint2();
+
+#endif // NS3_SOURCE_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/build-support/test-files/test-src-dependent-on-contrib/src-source.cc ns-3.41/build-support/test-files/test-src-dependent-on-contrib/src-source.cc
--- ns-3.40/build-support/test-files/test-src-dependent-on-contrib/src-source.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.41/build-support/test-files/test-src-dependent-on-contrib/src-source.cc	2024-02-09 14:44:07.725788800 -0800
@@ -0,0 +1,7 @@
+#include <ns3/contrib-header.h>
+
+void
+testPrint2()
+{
+    testPrint();
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/.clang-format ns-3.41/.clang-format
--- ns-3.40/.clang-format	2023-09-27 13:30:37.522838800 -0700
+++ ns-3.41/.clang-format	2024-02-09 14:44:07.717788700 -0800
@@ -26,4 +26,4 @@
 PointerAlignment: Left
 QualifierAlignment: Left
 SeparateDefinitionBlocks: Always
-Standard: "c++17"
+Standard: "c++20"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/.clang-tidy ns-3.41/.clang-tidy
--- ns-3.40/.clang-tidy	2023-09-27 13:30:37.522838800 -0700
+++ ns-3.41/.clang-tidy	2024-02-09 14:44:07.717788700 -0800
@@ -47,7 +47,6 @@
   readability-static-accessed-through-instance,
   readability-static-definition-in-anonymous-namespace,
   readability-string-compare,
-  readability-uppercase-literal-suffix,
 
 CheckOptions:
   - key: performance-unnecessary-copy-initialization.AllowedTypes
@@ -55,6 +54,9 @@
   - key: readability-simplify-boolean-expr.SimplifyDeMorgan
     value: false
 
+ExtraArgsBefore:
+  - -Wno-unknown-warning-option
+
 FormatStyle: "file"
 HeaderFilterRegex: ".*(ns|NS).*/(contrib|examples|src|scratch|utils)/*/.*h"
 UseColor: true
